function get(name)
    {
       if(document.getElementById) { return document.getElementById(name); }
       else if(document.all) { return document.all[name]; }
       else if(document.layers) { return document.layers[name]; }
    }

    var terms = new Array();
    var correct = new Array();


/*Fill terms and correct*/
terms[0] = "Which chords form an interrupted cadence?";
correct[0] = "V-VI";

terms[1] = "Which chords form a perfect cadence?";
correct[1] = "V-I";

terms[2] = "Which chords can form an imperfect cadence?";
correct[2] = "I-V, II-V, IV-V & VI-V";

terms[3] = "Which chord in a minor key is major? ";
correct[3] = "V";

terms[4] = "Which chords in a major key are minor?";
correct[4] = "II, III & VI";

terms[5] = "Which chord in any key is diminished?";
correct[5] = "VII";

terms[6] = "Which chord in a minor key is augmented?";
correct[6] = "III";

terms[7] = "Which chord is major in a minor key and minor in a major key?";
correct[7] = "VI";

terms[8] = "In an interrupted cadence, which voices should rise?";
correct[8] = "bass and leading note";

terms[9] = "Which chord(s) sound well preceding a perfect cadence?";
correct[9] = "II or VI in root position and cadential chords in first inversion";

terms[10] = "Which chords form the cadences in which the upper parts should move in contrary motion to the bass?";
correct[10] = "II-V, IV-V & V-VI";

terms[11] = "When writing 4 part harmony, which part is best to double in any chord other than VI?";
correct[11] = "root";

terms[12] = "When writing 4 part harmony, which part other than the root should you never omit from cadences?";
correct[12] = "third";

terms[13] = "When writing 4 part harmony, which part should you double in chord VI?";
correct[13] = "third";

terms[14] = "Which note should always rise to the tonic?";
correct[14] = "leading note";

terms[15] = "Which are the primary triads?";
correct[15] = "I, IV & V";

terms[16] = "Which first inversion chord(s) can lead into a cadence?";
correct[16] = "Ib, IIb, IVb & VIIb";

terms[17] = "When writing 4 part harmony, in which chord(s) can you double the minor third?";
correct[17] = "II, VI & VIIb";

terms[18] = "Which chords form the cadence that should have a descending third from the root of V to the 5th of VI?";
correct[18] = "V-VI";

terms[19]="When leading into a cadence, if using cadential chords, which inversion should they be in?";
correct[19]="first inversion";

terms[20]="Which chord should not be used in a minor key in root position?";
correct[20]="II";

terms[21]="Which chord should harmonise an anacrusis?";
correct[21]="V or Vb (occasionally I or Ib)";

terms[22]="When writing 4 part harmony, which note should never be doubled?";
correct[22]="leading note";

terms[23]="When using first inversion chords, what parts are best to double?";
correct[23]="3rd or 6th";

terms[24]="Which cadences should be used to indicate the music will continue?";
correct[24]="I-V, II-V, IV-V, VI-V or V-VI";

terms[25]="Which chords form the cadences that should be used to conclude a piece?";
correct[25]="IV-I or V-I";

terms[26]="What is another name for 'chord of the sixth'?";
correct[26]="first inversion";

terms[27]="When writing 4 part harmony, which intervals must be avoided between adjacent chords?";
correct[27]="consecutive (parallel) 5ths & 8ths";

terms[28]="Which chord is diminished in a minor key only?";
correct[28]="II";

terms[29]="Which are the secondary triads?";
correct[29]="II, III & VI in a major key and VI in a minor key";

    var selected = 0;

     var tindex = new Array();

     var count = 0;
     var total = 0;

     var indexes;

     function setA(x)
     {
        selected = x;
     }

     function initialise()
     {
        indexes = customIndex(terms.length);

        tindex = indexes;

        question();
     }



     var answeri = 0;
     function question()
     {
        chosenI = tindex.pop();

        cindex = customIndex(terms.length);
        cindex.splice(search(chosenI), 1);

       (get('termCell')).innerHTML = terms[chosenI];


        answeri = Math.floor(4*Math.random());

        (get('a')).innerHTML = correct[cindex.pop()];
        (get('b')).innerHTML = correct[cindex.pop()];
        (get('c')).innerHTML = correct[cindex.pop()];
        (get('d')).innerHTML = correct[cindex.pop()];
        (get('e')).innerHTML = correct[cindex.pop()];

        switch(answeri)
        {
           case 0: (get('a')).innerHTML = correct[chosenI]; break;
           case 1: (get('b')).innerHTML = correct[chosenI]; break;
           case 2: (get('c')).innerHTML = correct[chosenI]; break;
           case 3: (get('d')).innerHTML = correct[chosenI]; break;
           default: (get('e')).innerHTML = correct[chosenI];
        }
     }

     function answer()
     {
        if(selected == -1)
        {
           (get('feedback')).innerHTML = "Click a circle to continue";
       return;

        }


        if((selected == answeri) || compare(answeri))
        {
           count++;
           (get('feedback')).innerHTML = "Correct!";
        }
        else
        {
           (get('feedback')).innerHTML = "Answer for \"" + terms[chosenI]
            + "\" is \"" + correct[chosenI] + "\".";
        }
        total++;

        for(var i = 0; i < 5; i++)
        {
           (get('box' + i)).checked = false;
        }
        selected = -1;

        if(tindex.length > 0)
           question();
        else
           result();
     }

     function result()
     {
        lqw.innerHTML = "";
        feedback.innerHTML = "Finished! Score: " + count + "/" + total + ".";
        count = 0;
        total = 0;
     }

     function compare(answeri)
     {
        var temp = "";
        switch(selected)
        {
           case 0: temp = (get('a')).innerHTML; break;
           case 1: temp = (get('b')).innerHTML; break;
           case 2: temp = (get('c')).innerHTML; break;
           case 3: temp = (get('d')).innerHTML; break;
           case 4: temp = (get('e')).innerHTML; break;
        }

        switch(answeri)
        {
           case 0: tempb = (get('a')).innerHTML; break;
           case 1: tempb = (get('b')).innerHTML; break;
           case 2: tempb = (get('c')).innerHTML; break;
           case 3: tempb = (get('d')).innerHTML; break;
           case 4: tempb = (get('e')).innerHTML; break;
        }

        if(tempb == temp)
        {
           return true;
        }

        return false;
     }

function showURL(event)
{ widget.openURL('http://bloople.net/scripts/fourpartharmony.htm');
}
     ////////////////////////////////////CUSTOM TERMS INDEX SECTION///////////////////////////////////////////////////
     /*This function is used to fill tindex*/
     function customIndex(length)
     {
        var selected = unique(length);
        //alert("b");

        var out = new Array();
        for(var i = 0; i < length; i++)
        {
           out.push(selected[i]);
        }
        return out;
     }


     var used = new Array();
     function unique(length)
     {
        used = new Array();

        for(var i = 0; i < length; i++)
        {
           var current = Math.floor(length * Math.random());
           while(search(current) >= 0)
           {
              current = Math.floor(length * Math.random());
           }
           used.push(current);
        }

        return used;
     }

     function search(current)
     {
        for(var j = 0; j < used.length; j++)
        {
           if(current == used[j])
           {
              return j;
           }
        }
        return -1;
     }
     
