 function get(name)
   {
      if(document.getElementById) { return document.getElementById(name); }
      else if(document.all) { return document.all[name]; }
      else if(document.layers) { return document.layers[name]; }
   }

   var terms = new Array();
   var correct = new Array();



/*Fill terms and correct*/
terms[0] = "Which intervals should be avoided when writing a melody?";
correct[0] = "augmented 2nd & major 7th";

terms[1] = "Which interval can be used providing the FOLLOWING note is pitched within that interval?";
correct[1] = "diminished intervals";

terms[2] = "Which interval can only be used when the PRECEDING note is pitched within it?";
correct[2] = "octave";

terms[3] = "Which chord of the scale should be used to harmonise the beginning and ending note of a melody?";
correct[3] = "tonic";

terms[4] = "Which degree of the scale ought to be used for an anacrusis?";
correct[4] = "dominant or tonic";

terms[5] = "Which note should always FOLLOW use of the leading note?";
correct[5] = "tonic";

terms[6] = "What is the term used to describe a group of intervals repeated at a different pitch?";
correct[6] = "sequence";

terms[7] = "What is the term used to describe music where each part forms a melody in it's own right?";
correct[7] = "counterpoint, contrapuntal or polyphonic";

terms[8] = "What is the term used to describe when two parts move in opposite directions in pitch?";
correct[8] = "contrary motion";

terms[9] = "What is the term used to describe music that has one stationary part while another part moves in pitch?";
correct[9] = "oblique motion";

terms[10] = "What is the term used to describe music that has the pitch of two parts move in the same direction?";
correct[10] = "similar motion";

terms[11] = "What is the term used to describe a melody that uses turns, mordants or trills?";
correct[11] = "ornamented or decorated";

terms[12] = "What is the term used to describe harmonisation that primarily consists of chords?";
correct[12] = "homophonic";

terms[13]="Which movement of the Baroque Dance Suite has the melody line heavily ornamented?";
correct[13]="Allemande";

terms[14] = "What is another word for the term 'shake'?";
correct[14] = "trill";

terms[15]="What is another word for the term 'crushed note'?";
correct[15]="acciaccatura";

terms[16]="What is another word for the term 'leaning note'?";
correct[16]="appoggiatura";

terms[17]="Which ornament takes it's value from the note following?";
correct[17]="appoggiatura";

terms[18]="Which ornament takes it's value from the preceding note or rest?";
correct[18]="acciaccatura";

terms[19]="What is the term for a note foreign to the key signature?";
correct[19]="accidental";

 var selected = 0;

 var tindex = new Array();

 var count = 0;
 var total = 0;

 var indexes;

 function setA(x)
 {
    selected = x;
 }

 function initialise()
 {
    indexes = customIndex(terms.length);

    tindex = indexes;

    question();
 }



 var answeri = 0;
 function question()
 {
    chosenI = tindex.pop();

    cindex = customIndex(terms.length);
    cindex.splice(search(chosenI), 1);
	
  (get('termCell')).innerHTML = terms[chosenI];


    answeri = Math.floor(4*Math.random());

    (get('a')).innerHTML = correct[cindex.pop()];
    (get('b')).innerHTML = correct[cindex.pop()];
    (get('c')).innerHTML = correct[cindex.pop()];
    (get('d')).innerHTML = correct[cindex.pop()];
    (get('e')).innerHTML = correct[cindex.pop()];

    switch(answeri)
    {
       case 0: (get('a')).innerHTML = correct[chosenI]; break;
       case 1: (get('b')).innerHTML = correct[chosenI]; break;
       case 2: (get('c')).innerHTML = correct[chosenI]; break;
       case 3: (get('d')).innerHTML = correct[chosenI]; break;
       default: (get('e')).innerHTML = correct[chosenI];
    }
 }

 function answer()
 {
    if(selected == -1)
    {
       (get('feedback')).innerHTML = "Click a circle to continue";
       return;
    }


    if((selected == answeri) || compare(answeri))
    {
       count++;
       (get('feedback')).innerHTML = "Correct!";
    }
    else
    {
       (get('feedback')).innerHTML = "The correct answer for \"" + terms[chosenI]
        + "\" is \"" + correct[chosenI] + "\".";
    }
    total++;

    for(var i = 0; i < 5; i++)
    {
       (get('box' + i)).checked = false;
    }
    selected = -1;

    if(tindex.length > 0)
       question();
    else
       result();
 }

 function result()
 {
    lqw.innerHTML = "";
    feedback.innerHTML = "Finished! Score:" + count + "/" + total + ".";
    count = 0;
    total = 0;
 }

 function compare(answeri)
 {
    var temp = "";
    switch(selected)
    {
       case 0: temp = (get('a')).innerHTML; break;
       case 1: temp = (get('b')).innerHTML; break;
       case 2: temp = (get('c')).innerHTML; break;
       case 3: temp = (get('d')).innerHTML; break;
       case 4: temp = (get('e')).innerHTML; break;
    }

    switch(answeri)
    {
       case 0: tempb = (get('a')).innerHTML; break;
       case 1: tempb = (get('b')).innerHTML; break;
       case 2: tempb = (get('c')).innerHTML; break;
       case 3: tempb = (get('d')).innerHTML; break;
       case 4: tempb = (get('e')).innerHTML; break;
    }

    if(tempb == temp)
    {
       return true;
    }

    return false;
 }

 ////////////////////////////////////CUSTOM TERMS INDEX SECTION///////////////////////////////////////////////////
 /*This function is used to fill tindex*/
 function customIndex(length)
 {
    var selected = unique(length);
    //alert("b");

    var out = new Array();
    for(var i = 0; i < length; i++)
    {
       out.push(selected[i]);
    }
    return out;
 }


 var used = new Array();
 function unique(length)
 {
    used = new Array();

    for(var i = 0; i < length; i++)
    {
       var current = Math.floor(length * Math.random());
       while(search(current) >= 0)
       {
          current = Math.floor(length * Math.random());
       }
       used.push(current);
    }

    return used;
 }

 function search(current)
 {
    for(var j = 0; j < used.length; j++)
    {
       if(current == used[j])
       {
          return j;
       }
    }
    return -1;
 }
