
   
	   function get(name)
   {
      if(document.getElementById) { return document.getElementById(name); }
      else if(document.all) { return document.all[name]; }
      else if(document.layers) { return document.layers[name]; }
   }

   var terms = new Array();
   var correct = new Array();


/*Fill terms and correct*/
terms[0] = "C major";
correct[0] = "A minor";

terms[1] = "G major";
correct[1] = "E minor";

terms[2] = "D major";
correct[2] = "B minor";

terms[3] = "A major";
correct[3] = "F# minor";

terms[4] = "E major";
correct[4] = "C# minor";

terms[5] = "B major";
correct[5] = "G# minor";

terms[6] = "F# major";
correct[6] = "D# minor";

terms[7] = "C# major";
correct[7] = "A# minor";

terms[8] = "F major";
correct[8] = "D minor";

terms[9] = "Bb major";
correct[9] = "G minor";

terms[10] = "Eb major";
correct[10] = "C minor";

terms[11] = "Ab major";
correct[11] = "F minor";

terms[12] = "Db major";
correct[12] = "Bb minor";

terms[13] = "Gb major";
correct[13] = "Eb minor";

terms[14] = "Cb major";
correct[14] = "Ab minor";

 var selected = 0;

 var tindex = new Array();

 var count = 0;
 var total = 0;

 var indexes;

 function setA(x)
 {
    selected = x;
 }

 function initialise()
 {
    indexes = customIndex(terms.length);

    tindex = indexes;

    question();
 }



 var answeri = 0;
 function question()
 {
    chosenI = tindex.pop();

    cindex = customIndex(terms.length);
    cindex.splice(search(chosenI), 1);

     (get('termCell')).innerHTML = terms[chosenI];


    answeri = Math.floor(4*Math.random());

    (get('a')).innerHTML = correct[cindex.pop()];
    (get('b')).innerHTML = correct[cindex.pop()];
    (get('c')).innerHTML = correct[cindex.pop()];
    (get('d')).innerHTML = correct[cindex.pop()];
    (get('e')).innerHTML = correct[cindex.pop()];

    switch(answeri)
    {
       case 0: (get('a')).innerHTML = correct[chosenI]; break;
       case 1: (get('b')).innerHTML = correct[chosenI]; break;
       case 2: (get('c')).innerHTML = correct[chosenI]; break;
       case 3: (get('d')).innerHTML = correct[chosenI]; break;
       default: (get('e')).innerHTML = correct[chosenI];
    }
 }

 function answer()
 {
    if(selected == -1)
    {
      (get('feedback')).innerHTML = "Click a circle to continue";
       return;

    }


    if((selected == answeri) || compare(answeri))
    {
       count++;
       (get('feedback')).innerHTML = "Correct!";
    }
    else
    {
       (get('feedback')).innerHTML = "The relative key for \"" + terms[chosenI]
        + "\" is \"" + correct[chosenI] + "\".";
    }
    total++;

    for(var i = 0; i < 5; i++)
    {
       (get('box' + i)).checked = false;
    }
    selected = -1;

    if(tindex.length > 0)
       question();
    else
       result();
 }

 function result()
 {
    lqw.innerHTML = "";
    feedback.innerHTML = "Finished! Score:" + count + "/" + total + ".";
    count = 0;
    total = 0;
 }

 function compare(answeri)
 {
    var temp = "";
    switch(selected)
    {
       case 0: temp = (get('a')).innerHTML; break;
       case 1: temp = (get('b')).innerHTML; break;
       case 2: temp = (get('c')).innerHTML; break;
       case 3: temp = (get('d')).innerHTML; break;
       case 4: temp = (get('e')).innerHTML; break;
    }

    switch(answeri)
    {
       case 0: tempb = (get('a')).innerHTML; break;
       case 1: tempb = (get('b')).innerHTML; break;
       case 2: tempb = (get('c')).innerHTML; break;
       case 3: tempb = (get('d')).innerHTML; break;
       case 4: tempb = (get('e')).innerHTML; break;
    }

    if(tempb == temp)
    {
       return true;
    }

    return false;
 }





 ////////////////////////////////////CUSTOM TERMS INDEX SECTION///////////////////////////////////////////////////
 /*This function is used to fill tindex*/
 function customIndex(length)
 {
    var selected = unique(length);
    //alert("b");

    var out = new Array();
    for(var i = 0; i < length; i++)
    {
       out.push(selected[i]);
    }
    return out;
 }


 var used = new Array();
 function unique(length)
 {
    used = new Array();

    for(var i = 0; i < length; i++)
    {
       var current = Math.floor(length * Math.random());
       while(search(current) >= 0)
       {
          current = Math.floor(length * Math.random());
       }
       used.push(current);
    }

    return used;
 }

 function search(current)
 {
    for(var j = 0; j < used.length; j++)
    {
       if(current == used[j])
       {
          return j;
       }
    }
    return -1;
 }